"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const isFunction = require("lodash/isFunction");
class Module {
    constructor(app, options = {}) {
        this.app = app;
        this.log = app.log;
        this.options = options;
        // Until es7 have a way to initialize property
        if (this.moduleName) {
            this.config = this.prepareConfig(this.moduleName, (typeof this.defaultConfig === 'string')
                ? require(`${this.defaultConfig}/config/${this.moduleName}`).default
                : this.defaultConfig);
        }
        else {
            this.config = app.config;
        }
    }
    get name() {
        return this._name || this.constructor.name;
    }
    set name(newName) {
        this._name = newName;
    }
    // depreciated, use prepareConfig
    setConfig(ns, dConfig = {}) {
        this.log.warn(`setConfig is depreciated, use prepareConfig instead`);
        // return Object.assign(dConfig, this.app.config[ns], this.options)
    }
    prepareConfig(ns = '', dConfig = {}) {
        if (isFunction(dConfig)) {
            dConfig = dConfig(this.app);
        }
        if (ns) {
            return Object.assign(dConfig, this.app.config[ns], this.options);
        }
        else {
            return Object.assign(dConfig, this.options);
        }
    }
    insert(currentModule, ns) {
        if (!ns) {
            ns = this.moduleName;
        }
        if (this.app[ns]) {
            this.log.warn(`${this.name}: Module ${ns} already exist, overridden anyway`);
        }
        this.app[ns] = currentModule;
    }
    setup() {
        return __awaiter(this, void 0, void 0, function* () {
            this.log.warn(`Module ${this.name} missing setup function`);
        });
    }
    teardown() {
        return __awaiter(this, void 0, void 0, function* () { });
    }
}
exports.Module = Module;
//# sourceMappingURL=module.js.map